<template>
  <ob-form
    class="contract-location-form"
    :form-data="formData"
    :form-model="formModel"
    :is-read-only="!isDraft"
    data-qa="locationForm"
    @submit="onSubmitHandler"
    :ok-text="isNew ? 'Добавить' : 'Сохранить'"
    cancel-text="Отменить"
  >
    <p class="mb30">
      <template v-if="service.resourceSpeciesTitle">
        {{ service.serviceTypeTitle }}.<br>
        {{ service.resourceSpeciesTitle }}. {{service.resourceSubtypeTitle}}.
        {{ service.resourcePatternParameter }}. {{ service.serviceUnitTitle }}.
      </template>
      <template v-else>
        {{ service.serviceTypeTitle }}. {{ service.serviceUnitTitle }}.
      </template>
    </p>
    <template v-if="isNew">
      <ObSelect
        v-if="isNew"
        v-model="formData.locationUuid"
        label="Адрес"
        placeholder="Укажите локацию"
        :remote-opt="api.contract.getLocations"
        :is-auto-complete="true"
        display-exp="russian_name"
        class="mb20"
        data-qa="location"
      />
    </template>
    <template v-else>
      <ObInput
        v-model="dataSource.locationTitle"
        label="Адрес"
        :readonly="true"
        data-qa="location"
      />
    </template>
    <div
      v-if="isVatPayer"
      class="nds-row mb30 mt20"
    >
      <i class="icon alert" />
      <span>{{ service.isVatInclude ? 'Все тарифы включают в себя НДС' : 'Тарифы указываются без учета НДС' }} {{ service.vatValue || 20 }}%</span>
    </div>
    <div class="row mb15">
      <div class="col-xs-6">
        <div class="sub-title">
          <template v-if="formData.vatType !== 'NO_VAT'">
            Тариф дополнительной услуги:
          </template>
          <template v-else>
            Тариф дополнительной услуги без НДС
          </template>
        </div>
        <div class="row">
          <div class="col-xs-6">
            <ObInput
              v-model="formData.tariff"
              label="Тариф"
              sub-title="₽"
              placeholder="56 000"
              type="money:2"
              :readonly="!isDraft"
              data-qa="tariff"
            />
          </div>
        </div>
      </div>
    </div>
  </ob-form>
</template>

<script>
  import { mapState, mapGetters } from 'vuex'
  import api from '@/api'
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
  import models from '@/models'
  import cloneDeep from 'clone-deep'
  import ObForm from 'common-components/src/obComponents/obForm'
  import ObInput from 'common-components/src/obComponents/obInput'
  import ObSelect from 'common-components/src/obComponents/obSelect'

  export default {
    name: 'ContractLoactionForm',
    components: {
      ObSelect,
      ObInput,
      ObForm
    },
    mixins: [
      FormValidationMixin
    ],
    data () {
      return {
        api,
        dropdownMenu: [
          {
            label: 'Отключить направление',
            method: this.disableLocation
          }
        ]
      }
    },
    computed: {
      ...mapState({
        service: state => state.contract.editedService
      }),
      ...mapGetters({
        isDraft: 'contract/isDraft',
        isVatPayer: 'contract/isDoerVatPayer'
      }),
      formModel () {
        return models.contract.locations
      },
      isNew () {
        return !this.dataSource.locationUuid
      }
    },
    methods: {
      onSubmitHandler () {
        let data = cloneDeep(this.formData);
        this.$emit('submit', {formData: data, model: this.formModel})
      },
      disableLocation () {
        this.$emit('on-disable-location', { uuid: this.formData.locationUuid })
      }
    }
  }
</script>

<style lang='scss' scoped>
  @import '~common-components/src/static/css/mixins';

  .contract-location-form {
    .main-title {
      @include font-mixin(20px, 28px, 600, $color-text-base, 0.4px);
    }

    .sub-title {
      margin-bottom: 10px;
      @include font-mixin(16px, 24px, 600, $color-text-base, 0.4px);
    }

    .nds-row {
      width: 100%;
      display: flex;
      align-items: center;
      padding: 20px;
      background-color: $color-white-lilac;
      .icon {
        font-size: 24px;
        color: $color-blue-navy-blue;
      }
      span {
        padding-left: 20px;
        font-size: 14px;
        line-height: 20px;
        color: $color-text-base;
      }
    }
  }
</style>

<style lang="scss">
  .contract-location-form {
    .mt20 {
      margin-top: 20px!important;
    }

    .mb20 {
      margin-bottom: 20px !important;
    }

    .mb15 {
      margin-bottom: 15px !important;
    }

    .mb30 {
      margin-bottom: 30px!important;
    }

    .checkbox-input {
      display: flex;
      justify-content: flex-start;
      align-items: center;

      .ob-checkbox-container {
        flex-shrink: 0;
        margin-left: 20px;
      }
    }
  }
</style>
